VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4530
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4650
   LinkTopic       =   "Form1"
   ScaleHeight     =   4530
   ScaleWidth      =   4650
   StartUpPosition =   3  'Windows-Standard
   Begin VB.Frame Frame2 
      Caption         =   "Lizenz lesen"
      Height          =   1215
      Left            =   120
      TabIndex        =   8
      Top             =   2160
      Width           =   4455
      Begin VB.CommandButton Command2 
         Caption         =   "&Lizenz auslesen"
         Height          =   375
         Left            =   600
         TabIndex        =   11
         Top             =   720
         Width           =   3135
      End
      Begin VB.TextBox Text4 
         Alignment       =   1  'Rechts
         Height          =   285
         Left            =   1080
         TabIndex        =   10
         Top             =   240
         Width           =   3255
      End
      Begin VB.Label Label4 
         Caption         =   "Passwort:"
         Height          =   255
         Left            =   120
         TabIndex        =   9
         Top             =   240
         Width           =   1095
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Lizenz schreiben"
      Height          =   1935
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   4455
      Begin VB.TextBox Text3 
         Alignment       =   1  'Rechts
         Height          =   285
         Left            =   1080
         TabIndex        =   7
         Top             =   960
         Width           =   3255
      End
      Begin VB.CommandButton Command1 
         Caption         =   "&Lizenz erzeugen"
         Height          =   375
         Left            =   600
         TabIndex        =   5
         Top             =   1440
         Width           =   3135
      End
      Begin VB.TextBox Text2 
         Alignment       =   1  'Rechts
         Height          =   285
         Left            =   1080
         TabIndex        =   4
         Top             =   600
         Width           =   3255
      End
      Begin VB.TextBox Text1 
         Alignment       =   1  'Rechts
         Height          =   285
         Left            =   1080
         TabIndex        =   2
         Top             =   240
         Width           =   3255
      End
      Begin VB.Label Label3 
         Caption         =   "Passwort:"
         Height          =   255
         Left            =   120
         TabIndex        =   6
         Top             =   960
         Width           =   855
      End
      Begin VB.Label Label2 
         Caption         =   "Enddatum:"
         Height          =   255
         Left            =   120
         TabIndex        =   3
         Top             =   600
         Width           =   975
      End
      Begin VB.Label Label1 
         Caption         =   "Startdatum:"
         Height          =   255
         Left            =   120
         TabIndex        =   1
         Top             =   240
         Width           =   1215
      End
   End
   Begin VB.Label Label5 
      Caption         =   $"Form1.frx":0000
      Height          =   855
      Left            =   240
      TabIndex        =   12
      Top             =   3480
      Width           =   4215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private MyLicense As New License

Private Sub Command1_Click()
   MyLicense.StartDate = CDate(Text1.Text)
   MyLicense.EndDate = CDate(Text2.Text)
   MyLicense.PassWord = Text3.Text
   
   Call MyLicense.WriteTo(MakePath(App.Path) & "License.lic")
   Call MsgBox("Die Lizenz wurde in " & MakePath(App.Path) & "License.lic gespeichert.")
End Sub

Private Sub Command2_Click()
   MyLicense.PassWord = Text4.Text
   
   Select Case MyLicense.ReadFrom(MakePath(App.Path) & "License.lic")
      Case LicenseInfo.FileManipulated
         Call MsgBox("Die Lizenzdatei wurde verndert.")
      Case LicenseInfo.DateManipulated
         Call MsgBox("Die Windows-Uhr wurde verstellt.")
         ' Wenn an der Uhr gedreht wurde, darf die Lizenz nicht neu gespeichert werden,
         ' ansonsten wrde die genderte Zeit als letzte Zeit gespeichert - und das
         ' Rckdrehen der Uhr legitim. Mit einem zweifachen Start des Programms liee
         ' sich somit die Lizenz aushebeln. Deswegen: Prozedur verlassen (Alternativ:
         ' Setzen eines Flags, das beim Speichern der Lizenz bewertet wird)
         Exit Sub
      Case LicenseInfo.LicenseExpired
         Call MsgBox("Die Lizenz ist nicht mehr gltig." & vbCr & _
                     "Sie endete am " & CStr(MyLicense.EndDate) & ".")
      Case LicenseInfo.LicenseNotBegun
         Call MsgBox("Die Lizenz ist noch nicht gltig." & vbCr & _
                     "Sie beginnt erst am " & CStr(MyLicense.StartDate) & ".")
      Case LicenseInfo.WrongApplication
         Call MsgBox("Die Lizenz ist nicht mit dieser Anwendung kompatibel (falsches Passwort)")
      Case LicenseInfo.FileNotExisting
         Call MsgBox("Die Lizenzdatei konnte nicht gefunden werden.")
      Case LicenseInfo.LicenseOkay
         Call MsgBox("Die Lizenz ist gltig.")
   End Select
   
   ' Die Lizenz-Datei erneut speichern, damit LastDate aktualisiert wird...
   Call MyLicense.WriteTo(MakePath(App.Path) & "License.lic")
End Sub

Private Sub Form_Load()
   ' Standardwerte festlegen
   Text1.Text = Date
   Text2.Text = DateAdd("d", 30, Date)
End Sub

Private Function MakePath(ParamArray Parts() As Variant) As String
   Dim n As Long
   
   For n = 0 To UBound(Parts)
      MakePath = Parts(n) & IIf(Right(Parts(n), 1) = "\", "", "\")
   Next n
End Function
